Neuer Build
===========

* release: Wird ein *Tag* vergeben (egal welcher Branch) der mit 'v' beginnt, erzeugt das automatisch einen Build - https://w3.math.uzh.ch/qfq/release.
* snapshot: Jeder Commit (egal welcher Branch) erzeugt einen Snapshot - https://w3.math.uzh.ch/qfq/snapshot.
* nightly: Nach einem Commit auf Branch 'master' tagsueber, wird um 23:55 ein 'nightly' Build erstellt - https://w3.math.uzh.ch/qfq/nightly.
  * CR commmittet immer in den Master Branch.

Neue Versionsnummer
===================

1) Laufen die Unit Tests durch?

2) Die aktuellen Commits anschauen und wichtige Topics uebernehmen (git log > ~/qfq.log, alles bis zum letzten TAG anschauen):

   # complicated:  git log | grep -v -e '^commit ' -e  '^Author: ' -e '^Date: ' -e '^Merge: ' > /tmp/out; pluma  /tmp/out
   
   # Zeigt alle Commits an, die seit dem aendern von NewVersion gemacht wurden! Das sollten alle Commits seit der letzten Version sein.
   * git log --pretty=%s --after="`stat -c %y doc/NewVersion.md`"

   * qfq/extension/Documentation/Release.rst  
   * Den Inhalt von Release.rst kopieren nach qfq/extension/RELEASE.txt.
   * Den Inhalt von Release.rst kopieren nach CHANGELOG.md.

3) In folgenden Files anpassen:

   Auto: ./setVersion.sh <MAJOR>.<MINOR>.<MICRO>
   
   Manuell:
     * extension/Documentation/_make/conf.py: release, version
     * extension/Documentation/Settings.cfg: version
     * extension/ext_emconf.php: version

4) Im Projektverzeichnis:

   make t3sphinx   (dadurch fallen Fehler in der RESTdoc Syntax auf)

5) Commit
   * Update the version number in this document (topic 6)
   * Commit & Push new version changes to master branch: 
   
      New version x.y.z.

6) New Tag: 

   git tag v0.25.0
   git push -u origin v0.25.0

7) PhpStorm: Sync all files to VM qfq.


Update Doku auf docs.typo3.org
==============================

https://docs.typo3.org/typo3cms/drafts/github/T3DocumentationStarter/Public-Info-053/

1) Im `qfq` Projektverzeichnis: make update-qfq-doc
2) In `qfq-doc` Projektverzeichnis wechseln und auf github einchecken:
   git commit -a
   git push        # User: math-uzh, PW: <kpit>

one line:  make update-qfq-doc; pushd ../qfq-doc; git commit -a; git push; popd